use crate::prelude::*;
use library_loader::load_function_ptrs;

load_function_ptrs!(DeviceWSIFunctions, {
    vkQueuePresentKHR(queue: VkQueue, pPresentInfo: *const VkPresentInfoKHR) -> VkResult,

    vkCreateSwapchainKHR(
        device: VkDevice,
        pCreateInfo: *const VkSwapchainCreateInfoKHR,
        pAllocator: *const VkAllocationCallbacks,
        pSwapchain: *mut VkSwapchainKHR
    ) -> VkResult,

    vkDestroySwapchainKHR(
        device: VkDevice,
        swapchain: VkSwapchainKHR,
        pAllocator: *const VkAllocationCallbacks
    ) -> (),

    vkGetSwapchainImagesKHR(
        device: VkDevice,
        swapchain: VkSwapchainKHR,
        pSwapchainImageCount: *mut u32,
        pSwapchainImages: *mut VkImage
    ) -> VkResult,

    vkAcquireNextImageKHR(
        device: VkDevice,
        swapchain: VkSwapchainKHR,
        timeout: u64,
        semaphore: VkSemaphore,
        fence: VkFence,
        pImageIndex: *mut u32
    ) -> VkResult,
});

impl DeviceWSIFunctions {
    pub fn new(instance_functions: &InstanceFunctions, device: VkDevice) -> Self {
        Self::load(|name| unsafe {
            instance_functions.vkGetDeviceProcAddr(device, name.as_ptr()) as *const std::ffi::c_void
        })
    }
}
